

// Endogenous variables
var R tau pibar a pstar K F N C Y I mu chi s;

// Innovations
varexo eps_A eps_tau;

// PARAMETERS
parameters R_SS pibar_SS gam eps phi rho nu theta alpha rholambda phi_pie beta psiI psiN;

phi = 1;
rho = 0.9;
pibar_SS=1.0062;
//pibar_SS=1;
psiI=1;
psiN=1;
gam=.5;
beta=1.03^(-.25);
theta=0.75;
eps=6;
eps=7.7;
eps=12;%markup of 9 percent
phi=1;
%(1-nu)=(eps-1)/eps....1 - nu = 1 - 1/eps....nu=1/eps;
nu=1/eps;
alpha = 0.8;
//alpha = 0;
rholambda = 0.9;
phi_pie = 1.5;

[RR_SS,s_SS,pst_SS,mu_SS,C_SS,Y_SS,N_SS,TFP_dist_SS,K_SS,F_SS,I_SS,chi_SS] = ...
    ss_state(pibar_SS,beta,theta,eps,gam,psiI,psiN,nu,phi);

R_SS=RR_SS;

model;
# cst= (gam^gam*(1-gam)^(1-gam))^(1/gam);

//1 numbers are equation numbers in handout
(eps/(eps-1))*s*Y/C + beta*theta*(pibar(+1)^eps)*K(+1) - K;
//2
Y/C + (pibar(+1)^(eps-1))*beta*theta*F(+1) - F;
//3
F*( ((1-theta*pibar^(eps-1))/(1-theta))^(1/(1-eps)) ) - K;
//4
1/pstar - ((1-theta)*(((1-theta*(pibar)^(eps-1))/(1-theta))^(eps/(eps-1))) + theta*(pibar^eps)/pstar(-1));
//6
Y=pstar*exp(a)*N^gam*I^(1-gam);
//7
C+I=Y;
//8
I=mu*Y/pstar;
//9
s=(1-nu)*(((1-psiI+psiI*R)/(1-gam))^(1-gam))*((1-psiN+psiN*R)*exp(tau)*C*N^phi/gam)^gam*exp(-a);
//10
mu=(1-gam)*s/((1-nu)*(1-psiI+psiI*R));
//11
chi=(pstar*( (1-mu/pstar)/gam )^gam*( ((mu/pstar)/(1-gam))^(1-gam) ))^(1/gam);
//5
1/C - (beta/C(+1))*(R/pibar(+1));
//monetary policy rule
R/R_SS = ((R(-1)/R_SS)^alpha) * exp( (1-alpha) *  phi_pie*(pibar-pibar_SS) );
//
a=.95*a(-1)+eps_A;
tau = rholambda*tau(-1)+eps_tau;

end;

initval;
R=R_SS;
tau=0; 
pibar=pibar_SS; 
a=0; 
pstar=pst_SS; 
K=K_SS; 
F=F_SS;
N=N_SS;
C=C_SS;
I=I_SS;
s=s_SS;
Y=Y_SS;
chi=chi_SS;
mu=mu_SS;
end;

steady;
resid;
check;

shocks;
var eps_A;
stderr .01/2;
var eps_tau;
stderr .01;
end;

set_dynare_seed(1);
stoch_simul(order=2,nograph,pruning,periods=200);
sim2=oo_.endo_simul;
chi_gam_half2=sim2(end-1,:);
pstar_gam_half2=sim2(5,:);
C_gam_half2=100*(sim2(9,:)-C_SS)/C_SS;%this is 100 times the deviation between logC and its steady state value

set_dynare_seed('reset');
stoch_simul(order=2,nograph,pruning,periods=200);
sim2=oo_.endo_simul;
chi_gam_half2_np=sim2(end-1,:);
pstar_gam_half2_np=sim2(5,:);
C_gam_half2_np=100*(sim2(9,:)-C_SS)/C_SS;%this is 100 times the deviation between logC and its steady state value

set_dynare_seed('reset');
stoch_simul(order=1,nograph,periods=200);
sim1=oo_.endo_simul;
chi_gam_half1=sim1(end-1,:);
pstar_gam_half1=sim1(5,:);
C_gam_half1=100*(sim1(9,:)-C_SS)/C_SS;

% change the value of gam, in the 3rd element of params
gam=0.999;
M_.params( 3 ) = .999;

[RR_SS,s_SS,pst_SS,mu_SS,C_SS,Y_SS,N_SS,TFP_dist_SS,K_SS,F_SS,I_SS,chi_SS] = ...
    ss_state(pibar_SS,beta,theta,eps,gam,psiI,psiN,nu,phi);

initval;
R=R_SS;
tau=0; 
pibar=pibar_SS; 
a=0; 
pstar=pst_SS; 
K=K_SS; 
F=F_SS;
N=N_SS;
C=C_SS;
I=I_SS;
s=s_SS;
Y=Y_SS;
chi=chi_SS;
mu=mu_SS;
end;

set_dynare_seed('reset');
stoch_simul(order=2,nograph,pruning,periods=200);
sim2=oo_.endo_simul;
chi_gam_one2=sim2(end-1,:);
pstar_gam_one2=sim2(5,:);
C_gam_one2=100*(sim2(9,:)-C_SS)/C_SS;

set_dynare_seed('reset');
stoch_simul(order=2,nograph,periods=200);
sim2=oo_.endo_simul;
chi_gam_one2_np=sim2(end-1,:);
pstar_gam_one2_np=sim2(5,:);
C_gam_one2_np=100*(sim2(9,:)-C_SS)/C_SS;

set_dynare_seed('reset');
stoch_simul(order=1,nograph,periods=200);
sim1=oo_.endo_simul;
chi_gam_one1=sim1(end-1,:);
pstar_gam_one1=sim1(5,:);
C_gam_one1=100*(sim1(9,:)-C_SS)/C_SS;

subplot(2,2,1)
tt=1:length(chi_gam_one1);
plot(tt,chi_gam_half1,tt,chi_gam_half2,'*-',tt,chi_gam_half2_np,'o-')
legend('first order','second order','second order, no pruning','Location','Best')
ylabel('level')
title('Gamma = 1/2, chi')
axis tight

subplot(2,2,3)
plot(tt,chi_gam_one1,tt,chi_gam_one2,'*-',tt,chi_gam_one2_np,'o-')
legend('first order','second order','second order, no pruning','Location','Best')
ylabel('level')
title('Gamma = 1, chi')
axis tight

subplot(2,2,2)
plot(tt,C_gam_half1,tt,C_gam_half2,'*-',tt,C_gam_half2_np,'o-')
legend('first order','second order','second order, no pruning','Location','Best')
ylabel('perc dev from ss')
title('Gamma = 1/2, C')
axis tight

subplot(2,2,4)
plot(tt,C_gam_one1,tt,C_gam_one2,'*-',tt,C_gam_one2_np,'o-')
legend('first order ','second order','second order, no pruning','Location','Best')
ylabel('perc dev from ss')
title('Gamma = 1, C')
axis tight

sC_gam_one1=std(C_gam_one1);sC_gam_half1=std(C_gam_half1);sC_gam_one2=std(C_gam_one2);sC_gam_half2=std(C_gam_half2);
fprintf('sC_gam_one1 = %5.3f, sC_gam_half1 = %5.3f, sC_gam_one2 = %5.3f, sC_gam_half2 = %5.3f\n', ...
    sC_gam_one1,sC_gam_half1,sC_gam_one2,sC_gam_half2)
orient landscape
%print -dpdf materials_more_competition

